"""autogenerated by genpy from interactive_perception_msgs/ModelHypothesisList.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import interactive_perception_msgs.msg
import shape_msgs.msg
import std_msgs.msg

class ModelHypothesisList(genpy.Message):
  _md5sum = "4c912ee108200d2765bed511e89acbff"
  _type = "interactive_perception_msgs/ModelHypothesisList"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """ModelHypothesis[] hypotheses

#initial guess if this can be a correct recognition result at all
bool accept
================================================================================
MSG: interactive_perception_msgs/ModelHypothesis
#describes a hypothesis about a recognized object (mesh+pose)

shape_msgs/Mesh mesh
geometry_msgs/PoseStamped pose

================================================================================
MSG: shape_msgs/Mesh
# Definition of a mesh

# list of triangles; the index values refer to positions in vertices[]
MeshTriangle[] triangles

# the actual vertices that make up the mesh
geometry_msgs/Point[] vertices

================================================================================
MSG: shape_msgs/MeshTriangle
# Definition of a triangle's vertices
uint32[3] vertex_indices

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  __slots__ = ['hypotheses','accept']
  _slot_types = ['interactive_perception_msgs/ModelHypothesis[]','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       hypotheses,accept

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ModelHypothesisList, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.hypotheses is None:
        self.hypotheses = []
      if self.accept is None:
        self.accept = False
    else:
      self.hypotheses = []
      self.accept = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.hypotheses)
      buff.write(_struct_I.pack(length))
      for val1 in self.hypotheses:
        _v1 = val1.mesh
        length = len(_v1.triangles)
        buff.write(_struct_I.pack(length))
        for val3 in _v1.triangles:
          buff.write(_struct_3I.pack(*val3.vertex_indices))
        length = len(_v1.vertices)
        buff.write(_struct_I.pack(length))
        for val3 in _v1.vertices:
          _x = val3
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v2 = val1.pose
        _v3 = _v2.header
        buff.write(_struct_I.pack(_v3.seq))
        _v4 = _v3.stamp
        _x = _v4
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v3.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v5 = _v2.pose
        _v6 = _v5.position
        _x = _v6
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v7 = _v5.orientation
        _x = _v7
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
      buff.write(_struct_B.pack(self.accept))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.hypotheses is None:
        self.hypotheses = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.hypotheses = []
      for i in range(0, length):
        val1 = interactive_perception_msgs.msg.ModelHypothesis()
        _v8 = val1.mesh
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v8.triangles = []
        for i in range(0, length):
          val3 = shape_msgs.msg.MeshTriangle()
          start = end
          end += 12
          val3.vertex_indices = _struct_3I.unpack(str[start:end])
          _v8.triangles.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v8.vertices = []
        for i in range(0, length):
          val3 = geometry_msgs.msg.Point()
          _x = val3
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v8.vertices.append(val3)
        _v9 = val1.pose
        _v10 = _v9.header
        start = end
        end += 4
        (_v10.seq,) = _struct_I.unpack(str[start:end])
        _v11 = _v10.stamp
        _x = _v11
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v10.frame_id = str[start:end].decode('utf-8')
        else:
          _v10.frame_id = str[start:end]
        _v12 = _v9.pose
        _v13 = _v12.position
        _x = _v13
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v14 = _v12.orientation
        _x = _v14
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        self.hypotheses.append(val1)
      start = end
      end += 1
      (self.accept,) = _struct_B.unpack(str[start:end])
      self.accept = bool(self.accept)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.hypotheses)
      buff.write(_struct_I.pack(length))
      for val1 in self.hypotheses:
        _v15 = val1.mesh
        length = len(_v15.triangles)
        buff.write(_struct_I.pack(length))
        for val3 in _v15.triangles:
          buff.write(val3.vertex_indices.tostring())
        length = len(_v15.vertices)
        buff.write(_struct_I.pack(length))
        for val3 in _v15.vertices:
          _x = val3
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v16 = val1.pose
        _v17 = _v16.header
        buff.write(_struct_I.pack(_v17.seq))
        _v18 = _v17.stamp
        _x = _v18
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v17.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v19 = _v16.pose
        _v20 = _v19.position
        _x = _v20
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v21 = _v19.orientation
        _x = _v21
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
      buff.write(_struct_B.pack(self.accept))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.hypotheses is None:
        self.hypotheses = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.hypotheses = []
      for i in range(0, length):
        val1 = interactive_perception_msgs.msg.ModelHypothesis()
        _v22 = val1.mesh
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v22.triangles = []
        for i in range(0, length):
          val3 = shape_msgs.msg.MeshTriangle()
          start = end
          end += 12
          val3.vertex_indices = numpy.frombuffer(str[start:end], dtype=numpy.uint32, count=3)
          _v22.triangles.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v22.vertices = []
        for i in range(0, length):
          val3 = geometry_msgs.msg.Point()
          _x = val3
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v22.vertices.append(val3)
        _v23 = val1.pose
        _v24 = _v23.header
        start = end
        end += 4
        (_v24.seq,) = _struct_I.unpack(str[start:end])
        _v25 = _v24.stamp
        _x = _v25
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v24.frame_id = str[start:end].decode('utf-8')
        else:
          _v24.frame_id = str[start:end]
        _v26 = _v23.pose
        _v27 = _v26.position
        _x = _v27
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v28 = _v26.orientation
        _x = _v28
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        self.hypotheses.append(val1)
      start = end
      end += 1
      (self.accept,) = _struct_B.unpack(str[start:end])
      self.accept = bool(self.accept)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_B = struct.Struct("<B")
_struct_3I = struct.Struct("<3I")
_struct_4d = struct.Struct("<4d")
_struct_2I = struct.Struct("<2I")
_struct_3d = struct.Struct("<3d")
